<!DOCTYPE html>
<html lang="en">
<head>
<meta charset=UTF-8 />
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="version" content="5"/>
<meta name="Description" content="HFS fileserver">
<meta name="mobile-web-app-capable" content="yes">
<link rel="icon" sizes="192x192" href="/icon.png">
<title>HFS %version%</title>
<style>
header {background:#555}
a, li span:last-child, small {cursor: pointer; text-decoration: none}
li a[href$="/"]::before {content:"\1f4c1"}
li>div, aside, header {display: flex; flex-wrap: wrap; justify-content: space-between; font-family:Helvetica; width:100%}
li {display:flex; padding: .3em 0; border-top: 1px solid #ddd}
li span {color:#757575}
a[href*="."]::before {content:"\1f4c4  "}
nav a[href*="."]::before {content:""}
a[href$=".mp3"]::before, a[href$=".ogg"]::before {content:"\266a  "}
a[href$=".jpg"]::before {content:"\1f304"}
img+div a[href$=".jpg"]::before {content:""}
a[href$=".mp4"]::before {content:"\1f39e  "} /*1f3ac*/
.checked {background:#f5f5f5}
.check main div span:last-child::after {content:" \2610"} /*26aa*/
.check .checked span:last-child::after {content:" \2611"} /*26ab*/
aside {padding: 1.33em 0}
nav {font-weight: bold; background:#cde}
small::after {content:" files"}
a[href$="/"]:active {background:#c2c2c2}
.dark {background:#555; color:white}
@media (prefers-color-scheme: dark) {  body, li a, li span, small a {   background-color: #555;   color: white;  }}
@media (min-width:480px) {header button::after {content:" "attr(id)} #Login>span:empty::after {content:" Login"}}
#Login::after {content:""}
nav a:first-child::before {content:"\2302 "} 
nav a {color:#000}
li a {-ms-hyphens:auto; -webkit-hyphens:auto; hyphens:auto}
nav a::after {content:"/"} /*" > "*/
/*button:disabled {display:none}*/
header {position:-webkit-sticky; position:sticky; top:0px} /**/
/*a+span:not(:empty)::after{content:"B"}*/
form {display:inline-block}
/*li span {margin-left:auto}*/ li a+span {margin:0px 10px 0px auto}
ul {padding-left: 0px;}
small::before {content:"\1f552"}
.err::before {background:rgba(255,0,0,0.5)}
#upload {width:74px; background: no-repeat -74px linear-gradient(#cde,#cde), #f0f0f0; transition:none}
#upload.loading {background-position:0px; transition: background .2s linear}
img {image-orientation:from-image; object-fit:cover}
/*main a[href="thumb/"], main a[href="thumb/"]~* {display:none}*/
</style>
</head>

<body>
<header><button id='upload' onclick="fileElem.click()" ondrop="event.preventDefault();sendFiles(event.dataTransfer.files)" ondragover="this.classList.add('loading');return false" title="&#x2196;&#x2261; &#x1f4c1;">&#x21e7;</button>
<input type="file" id="fileElem" multiple hidden onchange="sendFiles(this.files)">
<button id='Search' onclick="document.querySelector('dialog').showModal()">&#x2315;</button>
<dialog><form><input list='cat' type='search' placeholder='search...' name='qf'><input type='checkbox' checked title='subfolder'><button type="submit">&#x2315;</button></form> <button onclick='this.parentNode.close()'><sup>&times;</sup></button></dialog>
<datalist id='cat'><option value="*.jpg;*.png;*.gif">image</option><option value="*.mp3;*.ogg;*.m3u">audio</option><option value="*.mp4;*.webm;*.mkv">video</option><option value="*&sort=s&rev=1&">large files</option></datalist>
<button id='Delete' onclick="del()">X</button>
<button id='Login' onclick="if(this.firstElementChild.textContent) {document.execCommand('ClearAuthenticationCache');location.reload()} else location='/~login'">&#x1f464; <span>%user%</span></button>
<button id='Archive' onclick='del("Archive ")'>&#x21e9;</button>
</header>
<aside><nav onclick="if(!reload) {get(event.target.getAttribute('href'));return false}"></nav><small onclick="get(folder,'&sort=t')" title="sort&#xa;&#x2196;&#x2261; &#x263c;&#x2611;"><a href='javascript:void(0)'></a></small></aside>
<main id='files'><ul></ul></main>

<script>
const filemask='index.htm', reload=false; var thumbsize=64   //edit here
var folder=location.pathname.match(/.*\//)[0], b

function urlvar(key) {return (location.search.slice(1).match(key+'=(.*?)(&|$)')||'')[1]}
function get(val,para){ folder=val; para=para||'';
var sm=document.querySelector('small')

fetch(folder+'~files.lst?sort='+(urlvar('sort')||'n')+para).then(function(response) {
if(response.body && typeof(TextEncoder)!='undefined') {
  var reader = response.body.getReader(), txt='';

  reader.read().then(function processResult(result) {
    if (result.done) {
      if(txt.match(filemask)) location=folder;  // 
      sm.classList.remove("err"); const co=txt.match(/.*$/)[0].slice(1).split(',');upload.disabled=!co[0];Delete.disabled=!co[1];
      return;
    }
    
    var decoder = new TextDecoder();
    txt += decoder.decode(result.value, {stream: true})  // , true
    render(m3utojson(txt))
    return reader.read().then(processResult);
  });
} else return response.text().then(function(txt) {render(m3utojson(txt))})  //Edge<76
}).catch(error => sm.classList.add("err"));

}

get(folder)

function m3utojson(a) {
a=a.split(/\r?\n/);  b=[]
for (var i=1; i<a.length; i+=2) { b.push({url:a[i], modified:a[i-1].split(',')[0].slice(1,-3), size:a[i-1].split(/,0?/)[1]}) }
return b
}

function render(a){ const th=a.some(o => o.url=='thumb/'), la=(navigator.connection||{}).type!="cellular" && 'loading' in HTMLImageElement.prototype  //&&false
var myTemplate=a.map(function(item) {
 return "<li>"+
 (thumbsize && (th||la) && /\.jpg|\.png|\.gif/.test(item.url)? "<img src='"+folder+(th?"thumb/":"")+item.url+"' alt='thumb' loading='lazy' height='"+thumbsize+"' width='"+thumbsize+"'>":"")+
 "<div><a href=\'"+(item.url.slice(-1)=='/'?item.url+"\'":(item.url.match('://')?'':folder)+item.url+"\' target='l'")+">"+decodeURI(item.url).replace(/\/$/,'')+
 "</a><span>"+item.size.replace('N/A','')+"</span><span> "+item.modified+"</span></div></li>"

 })
document.querySelector('ul').innerHTML=myTemplate.join('\n')
document.querySelector('nav').innerHTML=bcrumbs(folder); document.querySelector('small>a').innerHTML='&nbsp;'+a.length  //+' ('+document.querySelectorAll('li a[href$="/"]').length+')'
if(typeof addon=='function') addon()  //
}

function bcrumbs(f) {
var path=f.split('/'), pt='', pr=''
for(pta=0;pta<path.length-1;pta++) {pt+=path[pta]+'/'; pr+='<a href="'+pt+'">'+(decodeURI(path[pta])||'Home')+'</a>'}  //+'/'
return pr
}

document.querySelector('form').onsubmit = function(){get(folder,1*this[0].nextElementSibling.checked? "&search="+this[0].value:"&filter=*"+this[0].value+"*"); this.parentNode.close();return false}  //files-filter

var dia=document.querySelector('dialog'); if(!dia.showModal) poly(dia)
function poly(node) {node.showModal=function(){this.hidden=false};  node.close=function(){this.hidden=true};  node.setAttribute('open',''); node.hidden=true}  //mypoly

document.querySelector('main').onclick=function(e){if(!reload&& e.target.tagName=='A' && !e.target.target &&!e.altKey) {get(folder+e.target.getAttribute('href'));return false} else
if(e.target.tagName=='SPAN'&&!e.target.nextSibling || e.target.tagName=='A'&&e.altKey) {e.target.parentNode.classList.toggle("checked");document.querySelector('small>a').innerHTML=document.querySelectorAll('.checked').length}}

document.querySelector('small').oncontextmenu= function(e) {e.preventDefault(); if(document.querySelector('.check')) document.querySelectorAll('main div').forEach(it => it.classList.add('checked')); else document.body.classList.toggle("dark")}  //longtouch clock
upload.oncontextmenu= function(e) {var tmp=prompt("new folder");if(tmp) fetch("/~mypage?id="+folder+tmp).then(res => get(folder)); return false}
</script>
<script>
function sendFiles(filesArray) { const limit=4295  //edit here MB
var fd = new FormData(), tsize=0, d0=Date.now()
Array.from(filesArray).forEach(item => {if(item.size>limit*1e6) return; tsize+=item.size; fd.append('myFile', item, item.name)})
upload.style.transitionDuration = tsize/parseFloat(upload.title)+"ms"; upload.classList.add("loading")
fetch(folder,{method:'POST',body:fd}).then(response => {get(folder); upload.classList.remove("loading"); upload.title=(tsize/(Date.now()-d0)).toFixed()+' kb/s'})
}

function del(ar) {
var ref = document.querySelectorAll('.checked'), qstr=''
ref.forEach(item => qstr+='&selection='+item.firstChild.getAttribute('href'))
if(!qstr) {document.querySelector('body').classList.toggle("check"); return}
if(!confirm((ar||"Delete ")+ref.length+" file(s) ?")) return
ct={"Content-type":"application/x-www-form-urlencoded"}; 
if(!ar) fetch(folder,{method:'POST',body:"action=delete"+qstr,headers:ct}).then(response => get(folder))
else fetch(folder+"?mode=archive&recursive",{method:'POST',body:qstr,headers:ct}).then(response => response.blob()).then(data =>{a.href=URL.createObjectURL(data);a.click()})
}
var a=document.createElement("a"); a.download='selection.tar'; document.body.appendChild(a)
</script>
</body>
</html>

<footer hidden>
[not found]
<h1>Not found</h1><a href="/">&#x2302; Home</a>

[unauthorized]
<h1>Unauthorized</h1>
&#x26d4; wrong username or password

[special:import]
{.if not|{.exists|hfs.filelist.tpl.}|{:{.dialog|Add hfs.filelist.tpl from zip to folder, that contains hfs.exe.}:}.}

[overload]
<h1>Service Unavailable</h1>overloaded Retry later   

[mypage]
{.mkdir|{.force ansi|{.?id.}.}.}

